variables:
  DEPLOY_PAGES:
    value: 'true'
    description: Deploys embedded code docs as a GitLab pages site when 'true'.
  TF_ROOT:
    value: terraform
    description: The root directory of the terraform project.
  TF_DESTROY:
    value: 'false'
    description: Whether to enable the destroy job.
  WORKSPACE:
    value: master
    description: The environment to deploy to.
  ENV_URL:
    value: https://app.contentful.com/spaces/$CONTENTFUL_SPACE_ID/home
    description: The URL which the environment is deployed to.

include:
  - project: ben_goodman/utility/pipeline_templates
    file:
      - base/config/trunk_workflow.gitlab-ci.yml
      - recipes/deploy_code_docs.gitlab-ci.yml
      - recipes/deploy_terraform.gitlab-ci.yml
      - recipes/publish_npm.gitlab-ci.yml

.get_secrets: &get_secrets
  - |
    source <(
      aws secretsmanager get-secret-value \
        --secret-id 'contentful/api/blog' \
        --query SecretString \
        --output text \
      | jq -r 'keys[] as $k | "export \($k)=\(.[$k])"'
    )

default:
  image: registry.gitlab.com/ben_goodman/utility/images/nodejs-builder-20.5.1:stable
  tags:
    - linux
    - md
  before_script:
    - *get_secrets

Build:
  needs:
    - Apply Terraform

pages:
  image: registry.gitlab.com/ben_goodman/utility/images/nodejs-builder-20.5.1:stable
  tags:
    - linux
    - md